package com.lantone.qc.dbanaly.facade.yiwu;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.lantone.qc.pub.util.StringUtil;
import org.dom4j.Document;
import org.dom4j.DocumentHelper;
import org.dom4j.Element;

import java.util.List;
import java.util.Map;

/**
 * @Description: xml解析工具
 * @author: rengb
 * @time: 2020/3/28 14:23
 */
public class YiWuXmlUtil {

    public static Map<String, String> xmlToMap(String xml) {
        Map<String, String> map = Maps.newHashMap();
        try {
            Document doc = DocumentHelper.parseText(xml);
            Element root = (Element) doc.selectSingleNode("//XTextDocument/XElements/Element[@xsi:type='XTextBody']/XElements");
            findElement(root, "XInputField").forEach(i -> {
                xInputField(map, i);
            });
            findElement(root, "XTextTable").forEach(tableElement -> {
                findElement(tableElement.element("XElements"), "XTextTableRow").forEach(rowElement -> {
                    findElement(rowElement.element("XElements"), "XTextTableCell").forEach(cellElement -> {
                        findElement(cellElement.element("XElements"), "XInputField").forEach(xInputFieldElement -> {
                            xInputField(map, xInputFieldElement);
                        });
                    });
                });
            });
        } catch (Exception e) {
        }
        map.keySet().forEach(key -> {
            System.out.println(key + "----" + map.get(key));
        });
        return map;
    }

    public static List<Element> findElement(Element element, String attual) {
        List<Element> ret = Lists.newArrayList();
        ((List<Element>) (element.elements())).forEach(i -> {
            if (StringUtil.isNotBlank(i.attributeValue("type")) && i.attributeValue("type").equals(attual)) {
                ret.add(i);
            }
        });
        return ret;
    }

    public static void xInputField(Map<String, String> map, Element xInputFieldElement) {
        String key = null, value = null;
        String[] elementNames = { "ToolTip", "Name", "BackgroundText", "ID" };
        for (String elementName : elementNames) {
            key = xInputFieldElement.elementTextTrim(elementName);
            if (StringUtil.isNotBlank(key)) {
                break;
            }
        }
        value = xInputFieldElement.elementTextTrim("InnerValue");
        if (StringUtil.isNotBlank(key)) {
            map.put(key, value);
        }
    }


}